# -*- coding: utf-8 -*-
"""
Created on Tue May 26 11:28:52 2015

@author: Project Rainbow
"""

import math
import scipy.integrate
import matplotlib.pyplot as plt
from numpy import linspace
from matplotlib.ticker import AutoMinorLocator

wavelength=1064*10**-9
L=.27
Po=1



#
def cavity_mode(roc):
    A=1+((2*L**2 - L*(4*roc))/(roc**2))
    B=2*L+((2*L**3)-3*L**2*(2*roc))/(2*roc**2)
    C=(4*L-2*roc)/(roc**2)
    D=1+(2*L**2-L*(4*roc))/(roc**2)
    if abs(A+D)>2:
        #print('cavity not stable')
        return(False)
    else:
        global Wo
        Wo=(wavelength/(2*math.pi))**.5 * (L*(2*roc-L))**.25
    return(True)

def test():
    for L in linspace(.24,.51,1000):    
        ROC=list()
        output=list()
        for roc in linspace(.12,.27,50):
            
            if cavity_mode(roc)==True:
                
                output.append((wavelength/(2*math.pi))**.5 * (L*(2*roc-L))**.25)
                ROC.append(roc)
                
        if output:
            plt.plot(ROC,output,label='L='+str(L))
    #plt.legend()
            
            
def test2():
    
    lengths=linspace(.1,1,100)
    output=list()
    for L in lengths:
        roc=L
        output.append(10**6*(wavelength/(2*math.pi))**.5 * (L*(2*roc-L))**.25)
        print((wavelength/(2*math.pi))**.5 * (L*(2*roc-L))**.25)
    plt.plot(lengths,output)
    
def spotsize(z,Wo):    
    Zr=math.pi*(Wo*Wo)/wavelength
    return((Wo*(1+((z)/Zr)**2)**.5))    


def I(r,z):
    Io=2*Po/(math.pi*Wo*Wo) 
    I=Io*(Wo/(spotsize(z,Wo)))**2*math.e**(-2*r**2/(spotsize(z,Wo)**2))
    return(I)
    
    
def rint_I(z):
    Io=2*Po/(math.pi*Wo*Wo) 
    return(Io*(Wo/(spotsize(z,Wo)))**2*((math.pi/2)**.5*spotsize(z,Wo)**2))
    
def rint_I_square(z):
    Io=2*Po/(math.pi*Wo*Wo) 
    return(.5*(Io**2)*(Wo/(spotsize(z,Wo)))**4*((math.pi)**.5*spotsize(z,Wo)))









 
def int_I():
    def cavity_mode(roc):
        if abs(A+D)>=2:
            #print('cavity not stable')
            return(False)
        else:
            global Wo
            Wo=(wavelength/(2*math.pi))**.5 * (L*(2*roc-L))**.25
            return(True)

    def spotsize(z,Wo):    
        Zr=math.pi*(Wo*Wo)/wavelength
        return((Wo*(1+((z)/Zr)**2)**.5))    
    
    
    def I(r,z):
        Io=2*Po/(math.pi*Wo*Wo) 
        I=Io*(Wo/(spotsize(z,Wo)))**2*math.e**(-2*r**2/(spotsize(z,Wo)**2))
        return(I)
        
 
        
    def rint_I_square(z):
        Io=2*Po/(math.pi*Wo*Wo) 
        return(.5*(Io**2)*(Wo/(spotsize(z,Wo)))**4*((math.pi)**.5*spotsize(z,Wo)))

    
    lengths=linspace(.1,1,10)   
      
    for L in lengths:
        int_square=list()
        ROC=list()        
        for roc in linspace(.55*L,4*lengths[-1]/3,500):        
            A=1+((2*L**2 - L*(4*roc))/(roc**2))
            B=2*L+(2*L**3-3*L**2*(2*roc))/(2*roc**2)
            C=(4*L-2*roc)/(roc**2)
            D=1+(2*L**2-L*(4*roc))/(roc**2)
            cavity_mode(roc)
            
            int_square.append(scipy.integrate.quad(rint_I_square,-L/2,L/2)[0]/27635428610)
            ROC.append(roc)
        plt.plot(ROC,int_square,'b')
        plt.annotate('  L='+str(L),(ROC[0],int_square[0]),ha='left')
        plt.tight_layout()  
    plt.xlabel('Mirror Radius of Curvature (m)',fontsize=15)
    plt.ylabel('Total Integrated I$^{2}$ (arb. units)',fontsize=15)
    for L,roc in ((.75,1),(.27,.3)):
                
        cavity_mode(roc)
        plt.plot([roc],[scipy.integrate.quad(rint_I_square,-L/2,L/2)[0]/27635428610],'ro')
        plt.annotate('   L='+str(L)+', R='+str(roc),(roc,scipy.integrate.quad(rint_I_square,-L/2,L/2)[0]/27635428610 +.03),ha='left')
    plt.tight_layout()  






 
def int_I_2():
    def cavity_mode(roc):
        if abs(A+D)>=2:
            #print('cavity not stable')
            return(False)
        else:
            global Wo
            Wo=(wavelength/(2*math.pi))**.5 * (L*(2*roc-L))**.25
            return(True)

    def spotsize(z,Wo):    
        Zr=math.pi*(Wo*Wo)/wavelength
        return((Wo*(1+((z)/Zr)**2)**.5))    
    
    
    def I(r,z):
        Io=2*Po/(math.pi*Wo*Wo) 
        I=Io*(Wo/(spotsize(z,Wo)))**2*math.e**(-2*r**2/(spotsize(z,Wo)**2))
        return(I)
        
 
        
    def rint_I_square(z):
        Io=2*Po/(math.pi*Wo*Wo) 
        return(.5*(Io**2)*(Wo/(spotsize(z,Wo)))**4*((math.pi)**.5*spotsize(z,Wo)))

    
    lengths=linspace(.05,1,1000)   
    int_square=list() 
    for L in lengths:
        roc=.55*L    
        A=1+((2*L**2 - L*(4*roc))/(roc**2))
        B=2*L+(2*L**3-3*L**2*(2*roc))/(2*roc**2)
        C=(4*L-2*roc)/(roc**2)
        D=1+(2*L**2-L*(4*roc))/(roc**2)
        cavity_mode(roc)
        int_square.append(scipy.integrate.quad(rint_I_square,-L/2,L/2)[0]/39082397943)
    plt.plot(lengths,int_square,'b')
    plt.title('Total Integrated I$^{2}$ vs Cavity Length for R=0.55L',fontsize=20)
    plt.xlabel('Cavity Length (m)',fontsize=15)
    plt.ylabel('Total Integrated I$^{2}$ (arb. units)',fontsize=15)
    plt.tight_layout()  
